<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>12.5. dbm — Interfaces to Unix “databases” &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="12. Data Persistence" href="persistence.html" />
    <link rel="next" title="12.6. sqlite3 — DB-API 2.0 interface for SQLite databases" href="sqlite3.html" />
    <link rel="prev" title="12.4. marshal — Internal Python object serialization" href="marshal.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="sqlite3.html" title="12.6. sqlite3 — DB-API 2.0 interface for SQLite databases"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="marshal.html" title="12.4. marshal — Internal Python object serialization"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="persistence.html" accesskey="U">12. Data Persistence</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-dbm">
<span id="dbm-interfaces-to-unix-databases"></span><h1>12.5. <a class="reference internal" href="#module-dbm" title="dbm: Interfaces to various Unix &quot;database&quot; formats."><code class="xref py py-mod docutils literal"><span class="pre">dbm</span></code></a> &#8212; Interfaces to Unix &#8220;databases&#8221;<a class="headerlink" href="#module-dbm" title="Permalink to this headline">¶</a></h1>
<p><a class="reference internal" href="#module-dbm" title="dbm: Interfaces to various Unix &quot;database&quot; formats."><code class="xref py py-mod docutils literal"><span class="pre">dbm</span></code></a> is a generic interface to variants of the DBM database &#8212;
<a class="reference internal" href="#module-dbm.gnu" title="dbm.gnu: GNU's reinterpretation of dbm. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">dbm.gnu</span></code></a> or <a class="reference internal" href="#module-dbm.ndbm" title="dbm.ndbm: The standard &quot;database&quot; interface, based on ndbm. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">dbm.ndbm</span></code></a>.  If none of these modules is installed, the
slow-but-simple implementation in module <a class="reference internal" href="#module-dbm.dumb" title="dbm.dumb: Portable implementation of the simple DBM interface."><code class="xref py py-mod docutils literal"><span class="pre">dbm.dumb</span></code></a> will be used.  There
is a <a class="reference external" href="http://www.jcea.es/programacion/pybsddb.htm">third party interface</a> to
the Oracle Berkeley DB.</p>
<dl class="exception">
<dt id="dbm.error">
<em class="property">exception </em><code class="descclassname">dbm.</code><code class="descname">error</code><a class="headerlink" href="#dbm.error" title="Permalink to this definition">¶</a></dt>
<dd><p>A tuple containing the exceptions that can be raised by each of the supported
modules, with a unique exception also named <a class="reference internal" href="#dbm.error" title="dbm.error"><code class="xref py py-exc docutils literal"><span class="pre">dbm.error</span></code></a> as the first
item &#8212; the latter is used when <a class="reference internal" href="#dbm.error" title="dbm.error"><code class="xref py py-exc docutils literal"><span class="pre">dbm.error</span></code></a> is raised.</p>
</dd></dl>

<dl class="function">
<dt id="dbm.whichdb">
<code class="descclassname">dbm.</code><code class="descname">whichdb</code><span class="sig-paren">(</span><em>filename</em><span class="sig-paren">)</span><a class="headerlink" href="#dbm.whichdb" title="Permalink to this definition">¶</a></dt>
<dd><p>This function attempts to guess which of the several simple database modules
available &#8212; <a class="reference internal" href="#module-dbm.gnu" title="dbm.gnu: GNU's reinterpretation of dbm. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">dbm.gnu</span></code></a>, <a class="reference internal" href="#module-dbm.ndbm" title="dbm.ndbm: The standard &quot;database&quot; interface, based on ndbm. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">dbm.ndbm</span></code></a> or <a class="reference internal" href="#module-dbm.dumb" title="dbm.dumb: Portable implementation of the simple DBM interface."><code class="xref py py-mod docutils literal"><span class="pre">dbm.dumb</span></code></a> &#8212; should
be used to open a given file.</p>
<p>Returns one of the following values: <code class="docutils literal"><span class="pre">None</span></code> if the file can&#8217;t be opened
because it&#8217;s unreadable or doesn&#8217;t exist; the empty string (<code class="docutils literal"><span class="pre">''</span></code>) if the
file&#8217;s format can&#8217;t be guessed; or a string containing the required module
name, such as <code class="docutils literal"><span class="pre">'dbm.ndbm'</span></code> or <code class="docutils literal"><span class="pre">'dbm.gnu'</span></code>.</p>
</dd></dl>

<dl class="function">
<dt id="dbm.open">
<code class="descclassname">dbm.</code><code class="descname">open</code><span class="sig-paren">(</span><em>file</em>, <em>flag='r'</em>, <em>mode=0o666</em><span class="sig-paren">)</span><a class="headerlink" href="#dbm.open" title="Permalink to this definition">¶</a></dt>
<dd><p>Open the database file <em>file</em> and return a corresponding object.</p>
<p>If the database file already exists, the <a class="reference internal" href="#dbm.whichdb" title="dbm.whichdb"><code class="xref py py-func docutils literal"><span class="pre">whichdb()</span></code></a> function is used to
determine its type and the appropriate module is used; if it does not exist,
the first module listed above that can be imported is used.</p>
<p>The optional <em>flag</em> argument can be:</p>
<table border="1" class="docutils">
<colgroup>
<col width="17%" />
<col width="83%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Value</th>
<th class="head">Meaning</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="docutils literal"><span class="pre">'r'</span></code></td>
<td>Open existing database for reading only
(default)</td>
</tr>
<tr class="row-odd"><td><code class="docutils literal"><span class="pre">'w'</span></code></td>
<td>Open existing database for reading and
writing</td>
</tr>
<tr class="row-even"><td><code class="docutils literal"><span class="pre">'c'</span></code></td>
<td>Open database for reading and writing,
creating it if it doesn&#8217;t exist</td>
</tr>
<tr class="row-odd"><td><code class="docutils literal"><span class="pre">'n'</span></code></td>
<td>Always create a new, empty database, open
for reading and writing</td>
</tr>
</tbody>
</table>
<p>The optional <em>mode</em> argument is the Unix mode of the file, used only when the
database has to be created.  It defaults to octal <code class="docutils literal"><span class="pre">0o666</span></code> (and will be
modified by the prevailing umask).</p>
</dd></dl>

<p>The object returned by <a class="reference internal" href="#dbm.open" title="dbm.open"><code class="xref py py-func docutils literal"><span class="pre">open()</span></code></a> supports the same basic functionality as
dictionaries; keys and their corresponding values can be stored, retrieved, and
deleted, and the <a class="reference internal" href="../reference/expressions.html#in"><code class="xref std std-keyword docutils literal"><span class="pre">in</span></code></a> operator and the <code class="xref py py-meth docutils literal"><span class="pre">keys()</span></code> method are
available, as well as <code class="xref py py-meth docutils literal"><span class="pre">get()</span></code> and <code class="xref py py-meth docutils literal"><span class="pre">setdefault()</span></code>.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.2: </span><code class="xref py py-meth docutils literal"><span class="pre">get()</span></code> and <code class="xref py py-meth docutils literal"><span class="pre">setdefault()</span></code> are now available in all database modules.</p>
</div>
<p>Key and values are always stored as bytes. This means that when
strings are used they are implicitly converted to the default encoding before
being stored.</p>
<p>These objects also support being used in a <a class="reference internal" href="../reference/compound_stmts.html#with"><code class="xref std std-keyword docutils literal"><span class="pre">with</span></code></a> statement, which
will automatically close them when done.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>Added native support for the context management protocol to the objects
returned by <a class="reference internal" href="#dbm.open" title="dbm.open"><code class="xref py py-func docutils literal"><span class="pre">open()</span></code></a>.</p>
</div>
<p>The following example records some hostnames and a corresponding title,  and
then prints out the contents of the database:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="kn">import</span> <span class="nn">dbm</span>

<span class="c"># Open database, creating it if necessary.</span>
<span class="k">with</span> <span class="n">dbm</span><span class="o">.</span><span class="n">open</span><span class="p">(</span><span class="s">&#39;cache&#39;</span><span class="p">,</span> <span class="s">&#39;c&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">db</span><span class="p">:</span>

    <span class="c"># Record some values</span>
    <span class="n">db</span><span class="p">[</span><span class="n">b</span><span class="s">&#39;hello&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">b</span><span class="s">&#39;there&#39;</span>
    <span class="n">db</span><span class="p">[</span><span class="s">&#39;www.python.org&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s">&#39;Python Website&#39;</span>
    <span class="n">db</span><span class="p">[</span><span class="s">&#39;www.cnn.com&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s">&#39;Cable News Network&#39;</span>

    <span class="c"># Note that the keys are considered bytes now.</span>
    <span class="k">assert</span> <span class="n">db</span><span class="p">[</span><span class="n">b</span><span class="s">&#39;www.python.org&#39;</span><span class="p">]</span> <span class="o">==</span> <span class="n">b</span><span class="s">&#39;Python Website&#39;</span>
    <span class="c"># Notice how the value is now in bytes.</span>
    <span class="k">assert</span> <span class="n">db</span><span class="p">[</span><span class="s">&#39;www.cnn.com&#39;</span><span class="p">]</span> <span class="o">==</span> <span class="n">b</span><span class="s">&#39;Cable News Network&#39;</span>

    <span class="c"># Often-used methods of the dict interface work too.</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">db</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s">&#39;python.org&#39;</span><span class="p">,</span> <span class="n">b</span><span class="s">&#39;not present&#39;</span><span class="p">))</span>

    <span class="c"># Storing a non-string key or value will raise an exception (most</span>
    <span class="c"># likely a TypeError).</span>
    <span class="n">db</span><span class="p">[</span><span class="s">&#39;www.yahoo.com&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="mi">4</span>

<span class="c"># db is automatically closed when leaving the with statement.</span>
</pre></div>
</div>
<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt>Module <a class="reference internal" href="shelve.html#module-shelve" title="shelve: Python object persistence."><code class="xref py py-mod docutils literal"><span class="pre">shelve</span></code></a></dt>
<dd>Persistence module which stores non-string data.</dd>
</dl>
</div>
<p>The individual submodules are described in the following sections.</p>
<div class="section" id="module-dbm.gnu">
<span id="dbm-gnu-gnu-s-reinterpretation-of-dbm"></span><h2>12.5.1. <a class="reference internal" href="#module-dbm.gnu" title="dbm.gnu: GNU's reinterpretation of dbm. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">dbm.gnu</span></code></a> &#8212; GNU&#8217;s reinterpretation of dbm<a class="headerlink" href="#module-dbm.gnu" title="Permalink to this headline">¶</a></h2>
<p>This module is quite similar to the <a class="reference internal" href="#module-dbm" title="dbm: Interfaces to various Unix &quot;database&quot; formats."><code class="xref py py-mod docutils literal"><span class="pre">dbm</span></code></a> module, but uses the GNU library
<code class="docutils literal"><span class="pre">gdbm</span></code> instead to provide some additional functionality.  Please note that the
file formats created by <a class="reference internal" href="#module-dbm.gnu" title="dbm.gnu: GNU's reinterpretation of dbm. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">dbm.gnu</span></code></a> and <a class="reference internal" href="#module-dbm.ndbm" title="dbm.ndbm: The standard &quot;database&quot; interface, based on ndbm. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">dbm.ndbm</span></code></a> are incompatible.</p>
<p>The <a class="reference internal" href="#module-dbm.gnu" title="dbm.gnu: GNU's reinterpretation of dbm. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">dbm.gnu</span></code></a> module provides an interface to the GNU DBM library.
<code class="docutils literal"><span class="pre">dbm.gnu.gdbm</span></code> objects behave like mappings (dictionaries), except that keys and
values are always converted to bytes before storing.  Printing a <code class="docutils literal"><span class="pre">gdbm</span></code>
object doesn&#8217;t print the
keys and values, and the <code class="xref py py-meth docutils literal"><span class="pre">items()</span></code> and <code class="xref py py-meth docutils literal"><span class="pre">values()</span></code> methods are not
supported.</p>
<dl class="exception">
<dt id="dbm.gnu.error">
<em class="property">exception </em><code class="descclassname">dbm.gnu.</code><code class="descname">error</code><a class="headerlink" href="#dbm.gnu.error" title="Permalink to this definition">¶</a></dt>
<dd><p>Raised on <a class="reference internal" href="#module-dbm.gnu" title="dbm.gnu: GNU's reinterpretation of dbm. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">dbm.gnu</span></code></a>-specific errors, such as I/O errors. <a class="reference internal" href="exceptions.html#KeyError" title="KeyError"><code class="xref py py-exc docutils literal"><span class="pre">KeyError</span></code></a> is
raised for general mapping errors like specifying an incorrect key.</p>
</dd></dl>

<dl class="function">
<dt id="dbm.gnu.open">
<code class="descclassname">dbm.gnu.</code><code class="descname">open</code><span class="sig-paren">(</span><em>filename</em><span class="optional">[</span>, <em>flag</em><span class="optional">[</span>, <em>mode</em><span class="optional">]</span><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#dbm.gnu.open" title="Permalink to this definition">¶</a></dt>
<dd><p>Open a <code class="docutils literal"><span class="pre">gdbm</span></code> database and return a <code class="xref py py-class docutils literal"><span class="pre">gdbm</span></code> object.  The <em>filename</em>
argument is the name of the database file.</p>
<p>The optional <em>flag</em> argument can be:</p>
<table border="1" class="docutils">
<colgroup>
<col width="17%" />
<col width="83%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Value</th>
<th class="head">Meaning</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="docutils literal"><span class="pre">'r'</span></code></td>
<td>Open existing database for reading only
(default)</td>
</tr>
<tr class="row-odd"><td><code class="docutils literal"><span class="pre">'w'</span></code></td>
<td>Open existing database for reading and
writing</td>
</tr>
<tr class="row-even"><td><code class="docutils literal"><span class="pre">'c'</span></code></td>
<td>Open database for reading and writing,
creating it if it doesn&#8217;t exist</td>
</tr>
<tr class="row-odd"><td><code class="docutils literal"><span class="pre">'n'</span></code></td>
<td>Always create a new, empty database, open
for reading and writing</td>
</tr>
</tbody>
</table>
<p>The following additional characters may be appended to the flag to control
how the database is opened:</p>
<table border="1" class="docutils">
<colgroup>
<col width="17%" />
<col width="83%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Value</th>
<th class="head">Meaning</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="docutils literal"><span class="pre">'f'</span></code></td>
<td>Open the database in fast mode.  Writes
to the database will not be synchronized.</td>
</tr>
<tr class="row-odd"><td><code class="docutils literal"><span class="pre">'s'</span></code></td>
<td>Synchronized mode. This will cause changes
to the database to be immediately written
to the file.</td>
</tr>
<tr class="row-even"><td><code class="docutils literal"><span class="pre">'u'</span></code></td>
<td>Do not lock database.</td>
</tr>
</tbody>
</table>
<p>Not all flags are valid for all versions of <code class="docutils literal"><span class="pre">gdbm</span></code>.  The module constant
<code class="xref py py-const docutils literal"><span class="pre">open_flags</span></code> is a string of supported flag characters.  The exception
<a class="reference internal" href="#dbm.gnu.error" title="dbm.gnu.error"><code class="xref py py-exc docutils literal"><span class="pre">error</span></code></a> is raised if an invalid flag is specified.</p>
<p>The optional <em>mode</em> argument is the Unix mode of the file, used only when the
database has to be created.  It defaults to octal <code class="docutils literal"><span class="pre">0o666</span></code>.</p>
<p>In addition to the dictionary-like methods, <code class="docutils literal"><span class="pre">gdbm</span></code> objects have the
following methods:</p>
<dl class="method">
<dt id="dbm.gnu.gdbm.firstkey">
<code class="descclassname">gdbm.</code><code class="descname">firstkey</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#dbm.gnu.gdbm.firstkey" title="Permalink to this definition">¶</a></dt>
<dd><p>It&#8217;s possible to loop over every key in the database using this method  and the
<a class="reference internal" href="#dbm.gnu.gdbm.nextkey" title="dbm.gnu.gdbm.nextkey"><code class="xref py py-meth docutils literal"><span class="pre">nextkey()</span></code></a> method.  The traversal is ordered by <code class="docutils literal"><span class="pre">gdbm</span></code>&#8216;s internal
hash values, and won&#8217;t be sorted by the key values.  This method returns
the starting key.</p>
</dd></dl>

<dl class="method">
<dt id="dbm.gnu.gdbm.nextkey">
<code class="descclassname">gdbm.</code><code class="descname">nextkey</code><span class="sig-paren">(</span><em>key</em><span class="sig-paren">)</span><a class="headerlink" href="#dbm.gnu.gdbm.nextkey" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns the key that follows <em>key</em> in the traversal.  The following code prints
every key in the database <code class="docutils literal"><span class="pre">db</span></code>, without having to create a list in memory that
contains them all:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="n">k</span> <span class="o">=</span> <span class="n">db</span><span class="o">.</span><span class="n">firstkey</span><span class="p">()</span>
<span class="k">while</span> <span class="n">k</span> <span class="o">!=</span> <span class="k">None</span><span class="p">:</span>
    <span class="nb">print</span><span class="p">(</span><span class="n">k</span><span class="p">)</span>
    <span class="n">k</span> <span class="o">=</span> <span class="n">db</span><span class="o">.</span><span class="n">nextkey</span><span class="p">(</span><span class="n">k</span><span class="p">)</span>
</pre></div>
</div>
</dd></dl>

<dl class="method">
<dt id="dbm.gnu.gdbm.reorganize">
<code class="descclassname">gdbm.</code><code class="descname">reorganize</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#dbm.gnu.gdbm.reorganize" title="Permalink to this definition">¶</a></dt>
<dd><p>If you have carried out a lot of deletions and would like to shrink the space
used by the <code class="docutils literal"><span class="pre">gdbm</span></code> file, this routine will reorganize the database.  <code class="docutils literal"><span class="pre">gdbm</span></code>
objects will not shorten the length of a database file except by using this
reorganization; otherwise, deleted file space will be kept and reused as new
(key, value) pairs are added.</p>
</dd></dl>

<dl class="method">
<dt id="dbm.gnu.gdbm.sync">
<code class="descclassname">gdbm.</code><code class="descname">sync</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#dbm.gnu.gdbm.sync" title="Permalink to this definition">¶</a></dt>
<dd><p>When the database has been opened in fast mode, this method forces any
unwritten data to be written to the disk.</p>
</dd></dl>

<dl class="method">
<dt id="dbm.gnu.gdbm.close">
<code class="descclassname">gdbm.</code><code class="descname">close</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#dbm.gnu.gdbm.close" title="Permalink to this definition">¶</a></dt>
<dd><p>Close the <code class="docutils literal"><span class="pre">gdbm</span></code> database.</p>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="module-dbm.ndbm">
<span id="dbm-ndbm-interface-based-on-ndbm"></span><h2>12.5.2. <a class="reference internal" href="#module-dbm.ndbm" title="dbm.ndbm: The standard &quot;database&quot; interface, based on ndbm. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">dbm.ndbm</span></code></a> &#8212; Interface based on ndbm<a class="headerlink" href="#module-dbm.ndbm" title="Permalink to this headline">¶</a></h2>
<p>The <a class="reference internal" href="#module-dbm.ndbm" title="dbm.ndbm: The standard &quot;database&quot; interface, based on ndbm. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">dbm.ndbm</span></code></a> module provides an interface to the Unix &#8220;(n)dbm&#8221; library.
Dbm objects behave like mappings (dictionaries), except that keys and values are
always stored as bytes. Printing a <code class="docutils literal"><span class="pre">dbm</span></code> object doesn&#8217;t print the keys and
values, and the <code class="xref py py-meth docutils literal"><span class="pre">items()</span></code> and <code class="xref py py-meth docutils literal"><span class="pre">values()</span></code> methods are not supported.</p>
<p>This module can be used with the &#8220;classic&#8221; ndbm interface or the GNU GDBM
compatibility interface. On Unix, the <strong class="program">configure</strong> script will attempt
to locate the appropriate header file to simplify building this module.</p>
<dl class="exception">
<dt id="dbm.ndbm.error">
<em class="property">exception </em><code class="descclassname">dbm.ndbm.</code><code class="descname">error</code><a class="headerlink" href="#dbm.ndbm.error" title="Permalink to this definition">¶</a></dt>
<dd><p>Raised on <a class="reference internal" href="#module-dbm.ndbm" title="dbm.ndbm: The standard &quot;database&quot; interface, based on ndbm. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">dbm.ndbm</span></code></a>-specific errors, such as I/O errors. <a class="reference internal" href="exceptions.html#KeyError" title="KeyError"><code class="xref py py-exc docutils literal"><span class="pre">KeyError</span></code></a> is raised
for general mapping errors like specifying an incorrect key.</p>
</dd></dl>

<dl class="data">
<dt id="dbm.ndbm.library">
<code class="descclassname">dbm.ndbm.</code><code class="descname">library</code><a class="headerlink" href="#dbm.ndbm.library" title="Permalink to this definition">¶</a></dt>
<dd><p>Name of the <code class="docutils literal"><span class="pre">ndbm</span></code> implementation library used.</p>
</dd></dl>

<dl class="function">
<dt id="dbm.ndbm.open">
<code class="descclassname">dbm.ndbm.</code><code class="descname">open</code><span class="sig-paren">(</span><em>filename</em><span class="optional">[</span>, <em>flag</em><span class="optional">[</span>, <em>mode</em><span class="optional">]</span><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#dbm.ndbm.open" title="Permalink to this definition">¶</a></dt>
<dd><p>Open a dbm database and return a <code class="docutils literal"><span class="pre">ndbm</span></code> object.  The <em>filename</em> argument is the
name of the database file (without the <code class="file docutils literal"><span class="pre">.dir</span></code> or <code class="file docutils literal"><span class="pre">.pag</span></code> extensions).</p>
<p>The optional <em>flag</em> argument must be one of these values:</p>
<table border="1" class="docutils">
<colgroup>
<col width="17%" />
<col width="83%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Value</th>
<th class="head">Meaning</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="docutils literal"><span class="pre">'r'</span></code></td>
<td>Open existing database for reading only
(default)</td>
</tr>
<tr class="row-odd"><td><code class="docutils literal"><span class="pre">'w'</span></code></td>
<td>Open existing database for reading and
writing</td>
</tr>
<tr class="row-even"><td><code class="docutils literal"><span class="pre">'c'</span></code></td>
<td>Open database for reading and writing,
creating it if it doesn&#8217;t exist</td>
</tr>
<tr class="row-odd"><td><code class="docutils literal"><span class="pre">'n'</span></code></td>
<td>Always create a new, empty database, open
for reading and writing</td>
</tr>
</tbody>
</table>
<p>The optional <em>mode</em> argument is the Unix mode of the file, used only when the
database has to be created.  It defaults to octal <code class="docutils literal"><span class="pre">0o666</span></code> (and will be
modified by the prevailing umask).</p>
<p>In addition to the dictionary-like methods, <code class="docutils literal"><span class="pre">ndbm</span></code> objects
provide the following method:</p>
<dl class="method">
<dt id="dbm.ndbm.ndbm.close">
<code class="descclassname">ndbm.</code><code class="descname">close</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#dbm.ndbm.ndbm.close" title="Permalink to this definition">¶</a></dt>
<dd><p>Close the <code class="docutils literal"><span class="pre">ndbm</span></code> database.</p>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="module-dbm.dumb">
<span id="dbm-dumb-portable-dbm-implementation"></span><h2>12.5.3. <a class="reference internal" href="#module-dbm.dumb" title="dbm.dumb: Portable implementation of the simple DBM interface."><code class="xref py py-mod docutils literal"><span class="pre">dbm.dumb</span></code></a> &#8212; Portable DBM implementation<a class="headerlink" href="#module-dbm.dumb" title="Permalink to this headline">¶</a></h2>
<div class="admonition note" id="index-0">
<p class="first admonition-title">Note</p>
<p class="last">The <a class="reference internal" href="#module-dbm.dumb" title="dbm.dumb: Portable implementation of the simple DBM interface."><code class="xref py py-mod docutils literal"><span class="pre">dbm.dumb</span></code></a> module is intended as a last resort fallback for the
<a class="reference internal" href="#module-dbm" title="dbm: Interfaces to various Unix &quot;database&quot; formats."><code class="xref py py-mod docutils literal"><span class="pre">dbm</span></code></a> module when a more robust module is not available. The <a class="reference internal" href="#module-dbm.dumb" title="dbm.dumb: Portable implementation of the simple DBM interface."><code class="xref py py-mod docutils literal"><span class="pre">dbm.dumb</span></code></a>
module is not written for speed and is not nearly as heavily used as the other
database modules.</p>
</div>
<p>The <a class="reference internal" href="#module-dbm.dumb" title="dbm.dumb: Portable implementation of the simple DBM interface."><code class="xref py py-mod docutils literal"><span class="pre">dbm.dumb</span></code></a> module provides a persistent dictionary-like interface which
is written entirely in Python.  Unlike other modules such as <a class="reference internal" href="#module-dbm.gnu" title="dbm.gnu: GNU's reinterpretation of dbm. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">dbm.gnu</span></code></a> no
external library is required.  As with other persistent mappings, the keys and
values are always stored as bytes.</p>
<p>The module defines the following:</p>
<dl class="exception">
<dt id="dbm.dumb.error">
<em class="property">exception </em><code class="descclassname">dbm.dumb.</code><code class="descname">error</code><a class="headerlink" href="#dbm.dumb.error" title="Permalink to this definition">¶</a></dt>
<dd><p>Raised on <a class="reference internal" href="#module-dbm.dumb" title="dbm.dumb: Portable implementation of the simple DBM interface."><code class="xref py py-mod docutils literal"><span class="pre">dbm.dumb</span></code></a>-specific errors, such as I/O errors.  <a class="reference internal" href="exceptions.html#KeyError" title="KeyError"><code class="xref py py-exc docutils literal"><span class="pre">KeyError</span></code></a> is
raised for general mapping errors like specifying an incorrect key.</p>
</dd></dl>

<dl class="function">
<dt id="dbm.dumb.open">
<code class="descclassname">dbm.dumb.</code><code class="descname">open</code><span class="sig-paren">(</span><em>filename</em><span class="optional">[</span>, <em>flag</em><span class="optional">[</span>, <em>mode</em><span class="optional">]</span><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#dbm.dumb.open" title="Permalink to this definition">¶</a></dt>
<dd><p>Open a <code class="docutils literal"><span class="pre">dumbdbm</span></code> database and return a dumbdbm object.  The <em>filename</em> argument is
the basename of the database file (without any specific extensions).  When a
dumbdbm database is created, files with <code class="file docutils literal"><span class="pre">.dat</span></code> and <code class="file docutils literal"><span class="pre">.dir</span></code> extensions
are created.</p>
<p>The optional <em>flag</em> argument supports only the semantics of <code class="docutils literal"><span class="pre">'c'</span></code>
and <code class="docutils literal"><span class="pre">'n'</span></code> values.  Other values will default to database being always
opened for update, and will be created if it does not exist.</p>
<p>The optional <em>mode</em> argument is the Unix mode of the file, used only when the
database has to be created.  It defaults to octal <code class="docutils literal"><span class="pre">0o666</span></code> (and will be modified
by the prevailing umask).</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span><a class="reference internal" href="#dbm.dumb.open" title="dbm.dumb.open"><code class="xref py py-func docutils literal"><span class="pre">open()</span></code></a> always creates a new database when the flag has the value
<code class="docutils literal"><span class="pre">'n'</span></code>.</p>
</div>
<p>In addition to the methods provided by the
<a class="reference internal" href="collections.abc.html#collections.abc.MutableMapping" title="collections.abc.MutableMapping"><code class="xref py py-class docutils literal"><span class="pre">collections.abc.MutableMapping</span></code></a> class, <code class="xref py py-class docutils literal"><span class="pre">dumbdbm</span></code> objects
provide the following methods:</p>
<dl class="method">
<dt id="dbm.dumb.dumbdbm.sync">
<code class="descclassname">dumbdbm.</code><code class="descname">sync</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#dbm.dumb.dumbdbm.sync" title="Permalink to this definition">¶</a></dt>
<dd><p>Synchronize the on-disk directory and data files.  This method is called
by the <code class="xref py py-meth docutils literal"><span class="pre">Shelve.sync()</span></code> method.</p>
</dd></dl>

<dl class="method">
<dt id="dbm.dumb.dumbdbm.close">
<code class="descclassname">dumbdbm.</code><code class="descname">close</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#dbm.dumb.dumbdbm.close" title="Permalink to this definition">¶</a></dt>
<dd><p>Close the <code class="docutils literal"><span class="pre">dumbdbm</span></code> database.</p>
</dd></dl>

</dd></dl>

</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">12.5. <code class="docutils literal"><span class="pre">dbm</span></code> &#8212; Interfaces to Unix &#8220;databases&#8221;</a><ul>
<li><a class="reference internal" href="#module-dbm.gnu">12.5.1. <code class="docutils literal"><span class="pre">dbm.gnu</span></code> &#8212; GNU&#8217;s reinterpretation of dbm</a></li>
<li><a class="reference internal" href="#module-dbm.ndbm">12.5.2. <code class="docutils literal"><span class="pre">dbm.ndbm</span></code> &#8212; Interface based on ndbm</a></li>
<li><a class="reference internal" href="#module-dbm.dumb">12.5.3. <code class="docutils literal"><span class="pre">dbm.dumb</span></code> &#8212; Portable DBM implementation</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="marshal.html"
                        title="previous chapter">12.4. <code class="docutils literal"><span class="pre">marshal</span></code> &#8212; Internal Python object serialization</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="sqlite3.html"
                        title="next chapter">12.6. <code class="docutils literal"><span class="pre">sqlite3</span></code> &#8212; DB-API 2.0 interface for SQLite databases</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/dbm.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="sqlite3.html" title="12.6. sqlite3 — DB-API 2.0 interface for SQLite databases"
             >next</a> |</li>
        <li class="right" >
          <a href="marshal.html" title="12.4. marshal — Internal Python object serialization"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="persistence.html" >12. Data Persistence</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>